// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	v1alpha1 "github.com/argoproj/argo/pkg/apis/workflow/v1alpha1"
	scheme "github.com/argoproj/argo/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// WorkflowEventBindingsGetter has a method to return a WorkflowEventBindingInterface.
// A group's client should implement this interface.
type WorkflowEventBindingsGetter interface {
	WorkflowEventBindings(namespace string) WorkflowEventBindingInterface
}

// WorkflowEventBindingInterface has methods to work with WorkflowEventBinding resources.
type WorkflowEventBindingInterface interface {
	Create(*v1alpha1.WorkflowEventBinding) (*v1alpha1.WorkflowEventBinding, error)
	Update(*v1alpha1.WorkflowEventBinding) (*v1alpha1.WorkflowEventBinding, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.WorkflowEventBinding, error)
	List(opts v1.ListOptions) (*v1alpha1.WorkflowEventBindingList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.WorkflowEventBinding, err error)
	WorkflowEventBindingExpansion
}

// workflowEventBindings implements WorkflowEventBindingInterface
type workflowEventBindings struct {
	client rest.Interface
	ns     string
}

// newWorkflowEventBindings returns a WorkflowEventBindings
func newWorkflowEventBindings(c *ArgoprojV1alpha1Client, namespace string) *workflowEventBindings {
	return &workflowEventBindings{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the workflowEventBinding, and returns the corresponding workflowEventBinding object, and an error if there is any.
func (c *workflowEventBindings) Get(name string, options v1.GetOptions) (result *v1alpha1.WorkflowEventBinding, err error) {
	result = &v1alpha1.WorkflowEventBinding{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("workfloweventbindings").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of WorkflowEventBindings that match those selectors.
func (c *workflowEventBindings) List(opts v1.ListOptions) (result *v1alpha1.WorkflowEventBindingList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.WorkflowEventBindingList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("workfloweventbindings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested workflowEventBindings.
func (c *workflowEventBindings) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("workfloweventbindings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a workflowEventBinding and creates it.  Returns the server's representation of the workflowEventBinding, and an error, if there is any.
func (c *workflowEventBindings) Create(workflowEventBinding *v1alpha1.WorkflowEventBinding) (result *v1alpha1.WorkflowEventBinding, err error) {
	result = &v1alpha1.WorkflowEventBinding{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("workfloweventbindings").
		Body(workflowEventBinding).
		Do().
		Into(result)
	return
}

// Update takes the representation of a workflowEventBinding and updates it. Returns the server's representation of the workflowEventBinding, and an error, if there is any.
func (c *workflowEventBindings) Update(workflowEventBinding *v1alpha1.WorkflowEventBinding) (result *v1alpha1.WorkflowEventBinding, err error) {
	result = &v1alpha1.WorkflowEventBinding{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("workfloweventbindings").
		Name(workflowEventBinding.Name).
		Body(workflowEventBinding).
		Do().
		Into(result)
	return
}

// Delete takes name of the workflowEventBinding and deletes it. Returns an error if one occurs.
func (c *workflowEventBindings) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("workfloweventbindings").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *workflowEventBindings) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("workfloweventbindings").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched workflowEventBinding.
func (c *workflowEventBindings) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.WorkflowEventBinding, err error) {
	result = &v1alpha1.WorkflowEventBinding{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("workfloweventbindings").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
